pub(crate) mod store;

// Modelable implementations
mod modelable;

/// A database value, aka a single column of a single row
pub trait Modelable {
    fn bind_to(&self, stmt: &mut sqlite::Statement, col: usize) -> sqlite::Result<()>;
    fn build_from(_stmt: &sqlite::Statement, _col_offset: usize) -> sqlite::Result<(Self, usize)>
    where
        Self: Sized,
    {
        unreachable!()
    }
    fn column_type() -> &'static str
    where
        Self: Sized,
    {
        unreachable!()
    }
}
